Index: krita/ui/canvas/kis_canvas2.cpp
===================================================================
--- krita/ui/canvas/kis_canvas2.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_canvas2.cpp	(working copy)
@@ -39,6 +39,7 @@
 #include <KoToolProxy.h>
 #include <KoSelection.h>
 
+#include "kis_coordinates_converter.h"
 #include "kis_prescaled_projection.h"
 #include "kis_image.h"
 #include "kis_doc2.h"
@@ -72,7 +73,8 @@
 public:
 
     KisCanvas2Private(KoCanvasBase * parent, KoViewConverter * viewConverter, KisView2 * view)
-        : viewConverter(viewConverter)
+        : coordinatesConverter(new KisCoordinatesConverter(viewConverter))
+        , viewConverter(viewConverter)
         , view(view)
         , canvasWidget(0)
         , shapeManager(new KoShapeManager(parent))
@@ -81,15 +83,17 @@
         , currentCanvasUsesOpenGLShaders(false)
         , toolProxy(new KoToolProxy(parent))
         , favoriteResourceManager(0)
-        , mirrorMode(false){
+        , canvasMirroredY(false) {
     }
 
     ~KisCanvas2Private() {
+        delete coordinatesConverter;
         delete favoriteResourceManager;
         delete shapeManager;
         delete toolProxy;
     }
 
+    KisCoordinatesConverter *coordinatesConverter;
     KoViewConverter *viewConverter;
     KisView2 *view;
     KisAbstractCanvasWidget *canvasWidget;
@@ -98,14 +102,12 @@
     bool currentCanvasIsOpenGL;
     bool currentCanvasUsesOpenGLShaders;
     KoToolProxy *toolProxy;
-    QPoint documentOffset;
-    KoShapeControllerBase *sc;
     KoFavoriteResourceManager *favoriteResourceManager;
-    bool mirrorMode;
 #ifdef HAVE_OPENGL
     KisOpenGLImageTexturesSP openGLImageTextures;
 #endif
     KisPrescaledProjectionSP prescaledProjection;
+    bool canvasMirroredY;
 };
 
 KisCanvas2::KisCanvas2(KoViewConverter * viewConverter, KisView2 * view, KoShapeControllerBase * sc)
@@ -114,13 +116,7 @@
 {
     KisConfig cfg;
     createCanvas(cfg.useOpenGL());
-    KisCanvasWidgetBase* baseWidget = dynamic_cast<KisCanvasWidgetBase*>(m_d->canvasWidget);
-    if (baseWidget){
-        baseWidget->setBorderColor(cfg.canvasBorderColor());
-    }else{
-        kWarning() << "Something is wrong with canvas! It is no longer KisCanvasWidgetBase";
-    }
-    
+
     connect(view->canvasController()->proxyObject, SIGNAL(moveDocumentOffset(const QPoint&)), SLOT(documentOffsetMoved(const QPoint&)));
     connect(KisConfigNotifier::instance(), SIGNAL(configChanged()), SLOT(slotConfigChanged()));
     connect(this, SIGNAL(canvasDestroyed(QWidget *)), this, SLOT(slotCanvasDestroyed(QWidget *)));
@@ -133,7 +129,7 @@
 
 void KisCanvas2::setCanvasWidget(QWidget * widget)
 {
-    connect(widget, SIGNAL(documentOriginChanged(const QPoint&)), this, SLOT(updateRulers()));
+    connect(widget, SIGNAL(needAdjustOrigin()), this, SLOT(adjustOrigin()), Qt::DirectConnection);
 
     KisAbstractCanvasWidget * tmp = dynamic_cast<KisAbstractCanvasWidget*>(widget);
     Q_ASSERT_X(tmp, "setCanvasWidget", "Cannot cast the widget to a KisAbstractCanvasWidget");
@@ -150,10 +146,6 @@
     KoCanvasControllerWidget *controller = dynamic_cast<KoCanvasControllerWidget*>(canvasController());
     if (controller) {
         Q_ASSERT(controller->canvas() == this);
-        // Avoids jumping and redrawing when changing zoom means the image fits in the area completely
-        controller->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
-        controller->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOn);
-
         controller->changeCanvasWidget(widget);
     }
 }
@@ -176,17 +168,64 @@
     return m_d->view->document()->gridData().snapToGrid();
 }
 
-bool KisCanvas2::isCanvasMirrored()
+void KisCanvas2::pan(QPoint shift)
 {
-    return m_d->mirrorMode;
+    KoCanvasControllerWidget* controller =
+        dynamic_cast<KoCanvasControllerWidget*>(canvasController());
+    controller->pan(shift);
 }
 
 void KisCanvas2::mirrorCanvas(bool enable)
 {
-    m_d->mirrorMode = enable;
-    updateCanvas();
+    if(enable != m_d->canvasMirroredY) {
+        QPointF oldCenterPoint = m_d->coordinatesConverter->flakeCenterPoint();
+
+        QTransform newTransform = m_d->coordinatesConverter->postprocessingTransform();
+        newTransform *= QTransform::fromScale(-1,1);
+        m_d->coordinatesConverter->setPostprocessingTransform(newTransform);
+        m_d->canvasMirroredY = enable;
+        notifyZoomChanged();
+
+        QPoint shift = m_d->coordinatesConverter->shiftFromFlakeCenterPoint(oldCenterPoint);
+        pan(shift);
+    }
 }
 
+void KisCanvas2::rotateCanvas(qreal angle)
+{
+    QPointF oldCenterPoint = m_d->coordinatesConverter->flakeCenterPoint();
+
+    QTransform newTransform = m_d->coordinatesConverter->postprocessingTransform();
+    QTransform temp; temp.rotate(angle);
+    newTransform *= temp;
+    m_d->coordinatesConverter->setPostprocessingTransform(newTransform);
+    notifyZoomChanged();
+
+    QPoint shift = m_d->coordinatesConverter->shiftFromFlakeCenterPoint(oldCenterPoint);
+    pan(shift);
+}
+
+void KisCanvas2::rotateCanvasRight15()
+{
+    rotateCanvas(15.);
+}
+
+void KisCanvas2::rotateCanvasLeft15()
+{
+    rotateCanvas(-15.);
+}
+
+void KisCanvas2::resetCanvasTransformations()
+{
+    QPointF oldCenterPoint = m_d->coordinatesConverter->flakeCenterPoint();
+
+    m_d->coordinatesConverter->setPostprocessingTransform(QTransform());
+    notifyZoomChanged();
+
+    QPoint shift = m_d->coordinatesConverter->shiftFromFlakeCenterPoint(oldCenterPoint);
+    pan(shift);
+}
+
 void KisCanvas2::addCommand(QUndoCommand *command)
 {
     m_d->view->koDocument()->addCommand(command);
@@ -232,6 +271,11 @@
     // TODO call (the protected) QWidget::updateMicroFocus() on the proper canvas widget...
 }
 
+const KisCoordinatesConverter* KisCanvas2::coordinatesConverter() const
+{
+    return m_d->coordinatesConverter;
+}
+
 const KoViewConverter* KisCanvas2::viewConverter() const
 {
     return m_d->viewConverter;
@@ -262,9 +306,9 @@
 {
     m_d->currentCanvasIsOpenGL = false;
 
-    KisQPainterCanvas * canvasWidget = new KisQPainterCanvas(this, m_d->view);
+    KisQPainterCanvas * canvasWidget = new KisQPainterCanvas(this, m_d->coordinatesConverter, m_d->view);
     m_d->prescaledProjection = new KisPrescaledProjection();
-    m_d->prescaledProjection->setViewConverter(m_d->viewConverter);
+    m_d->prescaledProjection->setCoordinatesConverter(m_d->coordinatesConverter);
     m_d->prescaledProjection->setMonitorProfile(monitorProfile());
     canvasWidget->setPrescaledProjection(m_d->prescaledProjection);
     setCanvasWidget(canvasWidget);
@@ -277,7 +321,7 @@
 
     // XXX: The image isn't done loading here!
     m_d->openGLImageTextures = KisOpenGLImageTextures::getImageTextures(m_d->view->image(), m_d->monitorProfile);
-    KisOpenGLCanvas2 * canvasWidget = new KisOpenGLCanvas2(this, m_d->view, m_d->openGLImageTextures);
+    KisOpenGLCanvas2 * canvasWidget = new KisOpenGLCanvas2(this, m_d->coordinatesConverter, m_d->view, m_d->openGLImageTextures);
     m_d->currentCanvasUsesOpenGLShaders = m_d->openGLImageTextures->usingHDRExposureProgram();
     setCanvasWidget(canvasWidget);
 #else
@@ -289,7 +333,7 @@
 {
     KisConfig cfg;
     slotSetDisplayProfile(KoColorSpaceRegistry::instance()->profileByName(cfg.monitorProfile()));
-    
+
     if (useOpenGL) {
 #ifdef HAVE_OPENGL
         if (QGLFormat::hasOpenGL()) {
@@ -313,7 +357,9 @@
 
 void KisCanvas2::connectCurrentImage()
 {
+    m_d->coordinatesConverter->setImage(m_d->view->image());
 
+
     if (m_d->currentCanvasIsOpenGL) {
 #ifdef HAVE_OPENGL
         Q_ASSERT(m_d->openGLImageTextures);
@@ -343,6 +389,8 @@
 
 void KisCanvas2::disconnectCurrentImage()
 {
+    m_d->coordinatesConverter->setImage(0);
+
     if (m_d->currentCanvasIsOpenGL) {
 #ifdef HAVE_OPENGL
         Q_ASSERT(m_d->openGLImageTextures);
@@ -371,6 +419,7 @@
         disconnectCurrentImage();
         createCanvas(useOpenGL);
         connectCurrentImage();
+        notifyZoomChanged();
     }
 
     if (useOpenGL) {
@@ -383,6 +432,7 @@
     }
 
 #endif
+
     m_d->canvasWidget->widget()->update();
 }
 
@@ -430,11 +480,10 @@
 
         m_d->prescaledProjection->recalculateCache(info);
 
-        QRect vRect = info->dirtyViewportRect();
-        if (m_d->mirrorMode){
-            m_d->canvasWidget->widget()->update();
-        }else if (!vRect.isEmpty()) {
-            vRect.translate(m_d->canvasWidget->documentOrigin());
+        QRect vRect = m_d->coordinatesConverter->
+            viewportToWidget(info->dirtyViewportRect()).toAlignedRect();
+
+        if (!vRect.isEmpty()) {
             m_d->canvasWidget->widget()->update(vRect);
         }
     }
@@ -445,32 +494,34 @@
     m_d->canvasWidget->widget()->update();
 }
 
-void KisCanvas2::updateCanvas(const QRectF& rc)
+void KisCanvas2::updateCanvas(const QRectF& documentRect)
 {
     // updateCanvas is called from tools, never from the projection
     // updates, so no need to prescale!
-    QRect vRect = viewRectFromDoc(rc);
-    if (!vRect.isEmpty()) {
-        m_d->canvasWidget->widget()->update(vRect);
+    QRect widgetRect = m_d->coordinatesConverter->documentToWidget(documentRect).toAlignedRect();
+    if (!widgetRect.isEmpty()) {
+        m_d->canvasWidget->widget()->update(widgetRect);
     }
 }
 
-void KisCanvas2::preScale()
+void KisCanvas2::notifyZoomChanged()
 {
+    m_d->coordinatesConverter->notifyZoomChanged();
+    adjustOrigin();
+
     if (!m_d->currentCanvasIsOpenGL) {
         Q_ASSERT(m_d->prescaledProjection);
-        m_d->prescaledProjection->preScale();
+        m_d->prescaledProjection->notifyZoomChanged();
     }
+    emit scrollAreaSizeChanged();
 }
 
-QRect KisCanvas2::viewRectFromDoc(const QRectF & rc)
+void KisCanvas2::preScale()
 {
-    QRect viewRect = m_d->viewConverter->documentToView(rc).toAlignedRect();
-    viewRect = viewRect.translated(-m_d->documentOffset);
-    // comment out this line if you want to see the preview outside of the canvas
-    // viewRect = viewRect.intersected(QRect(0, 0, m_d->canvasWidget->widget()->width(), m_d->canvasWidget->widget()->height()));
-    viewRect.translate(documentOrigin());
-    return viewRect;
+    if (!m_d->currentCanvasIsOpenGL) {
+        Q_ASSERT(m_d->prescaledProjection);
+        m_d->prescaledProjection->preScale();
+    }
 }
 
 KoColorProfile *  KisCanvas2::monitorProfile()
@@ -502,8 +553,16 @@
 
 void KisCanvas2::documentOffsetMoved(const QPoint &documentOffset)
 {
-    m_d->documentOffset = documentOffset;
-    m_d->canvasWidget->documentOffsetMoved(documentOffset);
+    QPointF offsetBefore = m_d->coordinatesConverter->widgetRectInFlakePixels().topLeft();
+    m_d->coordinatesConverter->setDocumentOffset(documentOffset);
+    QPointF offsetAfter = m_d->coordinatesConverter->widgetRectInFlakePixels().topLeft();
+
+    QPointF moveOffset = offsetAfter - offsetBefore;
+
+    if (!m_d->currentCanvasIsOpenGL)
+        m_d->prescaledProjection->viewportMoved(moveOffset);
+
+    updateCanvas();
 }
 
 bool KisCanvas2::usingHDRExposureProgram()
@@ -530,15 +589,6 @@
     if (useOpenGL) {
         cfg.setCanvasState("OPENGL_SUCCESS");
     }
-    
-    // due to canvas border update the canvas
-    KisCanvasWidgetBase * base = dynamic_cast<KisCanvasWidgetBase*>(m_d->canvasWidget);
-    if (base){
-        base->setBorderColor(cfg.canvasBorderColor());
-        m_d->canvasWidget->widget()->update();
-    }else{
-        kWarning() << "Something is wrong with canvas! It is no longer KisCanvasWidgetBase";
-    }
 }
 
 void KisCanvas2::slotSetDisplayProfile(const KoColorProfile * profile)
@@ -559,25 +609,33 @@
 
 QPoint KisCanvas2::documentOrigin() const
 {
-    return m_d->canvasWidget->documentOrigin();
+    return m_d->coordinatesConverter->documentOrigin();
 }
 
 
 void KisCanvas2::adjustOrigin()
 {
-    m_d->canvasWidget->adjustOrigin();
-}
+    QPoint newOrigin;
 
+    QSize documentSize = m_d->coordinatesConverter->imageRectInWidgetPixels().toAlignedRect().size();
+    QSize widgetSize = m_d->canvasWidget->widget()->size();
 
-void KisCanvas2::updateRulers()
-{
+    int widthDiff = widgetSize.width() - documentSize.width();
+    int heightDiff = widgetSize.height() - documentSize.height();
+
+    if (widthDiff > 0)
+        newOrigin.rx() = qRound(0.5 * widthDiff);
+    if (heightDiff > 0)
+        newOrigin.ry() = qRound(0.5 * heightDiff);
+
+    m_d->coordinatesConverter->setDocumentOrigin(newOrigin);
+
     emit documentOriginChanged();
 }
 
-
 QPoint KisCanvas2::documentOffset() const
 {
-    return m_d->documentOffset;
+    return m_d->coordinatesConverter->documentOffset();
 }
 
 void KisCanvas2::createFavoriteResourceManager(KisPaintopBox* paintopbox)
Index: krita/ui/canvas/kis_perspective_grid_manager.h
===================================================================
--- krita/ui/canvas/kis_perspective_grid_manager.h	(revision 1163293)
+++ krita/ui/canvas/kis_perspective_grid_manager.h	(working copy)
@@ -56,7 +56,7 @@
      */
     void clearPerspectiveGrid();
 protected:
-    virtual void drawDecoration(QPainter& gc, const QPoint& documentOffset,  const QRect& area, const KoViewConverter &converter);
+    void drawDecoration(QPainter& gc, const QRectF& updateRect, const KisCoordinatesConverter *converter);
 private:
     bool m_toggleEdition;
     KisView2* m_view;
Index: krita/ui/canvas/kis_prescaled_projection.cpp
===================================================================
--- krita/ui/canvas/kis_prescaled_projection.cpp	(revision 1163293)
+++ krita/ui/canvas/kis_prescaled_projection.cpp	(working copy)
@@ -36,6 +36,7 @@
 #include "kis_config_notifier.h"
 #include "kis_image.h"
 
+#include "kis_coordinates_converter.h"
 #include "kis_projection_backend.h"
 #include "kis_image_pyramid.h"
 
@@ -82,11 +83,7 @@
     Private()
             : useNearestNeighbour(false)
             , cacheKisImageAsQImage(true)
-            , documentOffset(0, 0)
-            , documentOrigin(0, 0)
-            , canvasSize(0, 0)
-            , imageSize(0, 0)
-            , viewConverter(0)
+            , viewportSize(0, 0)
             , monitorProfile(0)
             , projectionBackend(0) {
     }
@@ -100,13 +97,10 @@
 
     QImage prescaledQImage;
 
-    QPoint documentOffset; // in view pixels
-    QPoint documentOrigin; // in view pixels too
-
-    QSize canvasSize; // in view pixels
-    QSize imageSize; // in kisimage pixels
+    QSize canvasSize;
+    QSize viewportSize;
     KisImageWSP image;
-    KoViewConverter * viewConverter;
+    KisCoordinatesConverter *coordinatesConverter;
     const KoColorProfile* monitorProfile;
     KisProjectionBackend* projectionBackend;
 };
@@ -134,6 +128,7 @@
     m_d->image = image;
     m_d->projectionBackend->setImage(image);
 
+
     setImageSize(image->width(), image->height());
 }
 
@@ -142,9 +137,9 @@
     return m_d->prescaledQImage;
 }
 
-void KisPrescaledProjection::setViewConverter(KoViewConverter * viewConverter)
+void KisPrescaledProjection::setCoordinatesConverter(KisCoordinatesConverter *coordinatesConverter)
 {
-    m_d->viewConverter = viewConverter;
+    m_d->coordinatesConverter = coordinatesConverter;
 }
 
 void KisPrescaledProjection::initBackend(bool cacheKisImageAsQImage)
@@ -176,84 +171,63 @@
     setMonitorProfile(KoColorSpaceRegistry::instance()->profileByName(cfg.monitorProfile()));
 }
 
-
-void KisPrescaledProjection::documentOffsetMoved(const QPoint &documentOffset)
+void KisPrescaledProjection::viewportMoved(const QPointF &offset)
 {
-    dbgRender << "documentOffsetMoved " << m_d->documentOffset << ", to " << documentOffset;
-    QPoint oldDocumentOffset = m_d->documentOffset;
-    m_d->documentOffset = documentOffset;
+    // FIXME: \|/
+    if(m_d->prescaledQImage.isNull()) return;
+    if(offset.isNull()) return;
 
-    // We've called documentOffsetMoved before even updating the projection
-    if (m_d->prescaledQImage.isNull()) {
+    QPoint alignedOffset = offset.toPoint();
 
+    if(offset != alignedOffset) {
+        /**
+         * We can't optimize anything whe offset is float :(
+         * Just prescale entire image.
+         */
+        preScale();
         return;
     }
 
-    qint32 width = m_d->prescaledQImage.width();
-    qint32 height = m_d->prescaledQImage.height();
+    QImage newImage = QImage(m_d->viewportSize, QImage::Format_ARGB32);
 
-    QRegion exposedRegion = QRect(0, 0, width, height);
+    /**
+     * TODO: viewport rects should be cropped by the borders of
+     * the image, because it may be requested to read/write
+     * outside QImage and copyQImage will not chatch it
+     */
+    QRect newViewportRect = QRect(QPoint(0,0), m_d->viewportSize);
+    QRect oldViewportRect = newViewportRect.translated(-alignedOffset);
 
-    qint32 oldCanvasXOffset = oldDocumentOffset.x();
-    qint32 oldCanvasYOffset = oldDocumentOffset.y();
+    QRegion updateRegion = newViewportRect;
 
-    dbgRender << "w: " << width << ", h" << height << ", oldCanvasXOffset " << oldCanvasXOffset << ", oldCanvasYOffset " << oldCanvasYOffset
-    << ", new offset: " << documentOffset;
+    QRect savedArea = newViewportRect & oldViewportRect;
+    if(!savedArea.isEmpty()) {
+        copyQImage(-alignedOffset.x(), -alignedOffset.y(), &newImage, m_d->prescaledQImage);
+        updateRegion -= savedArea;
+    }
 
-    QImage image = QImage(width, height, QImage::Format_ARGB32);
-    QPainter gc(&image);
 
-    if (oldCanvasXOffset != m_d->documentOffset.x() || oldCanvasYOffset != m_d->documentOffset.y()) {
+    QPainter gc(&newImage);
+    QVector<QRect> rects = updateRegion.rects();
 
-        qint32 deltaX =  oldCanvasXOffset - m_d->documentOffset.x();
-        qint32 deltaY = oldCanvasYOffset - m_d->documentOffset.y();
-
-        dbgRender << "deltaX: " << deltaX << ", deltaY: " << deltaY;
-        if (qAbs(deltaX) < width && qAbs(deltaY) < height) {
-            dbgRender << "Copy old data";
-            copyQImage(deltaX, deltaY, &image, m_d->prescaledQImage);
-
-            dbgRender << "exposedRegion: " << exposedRegion;
-            dbgRender << "Preexistant data: " << QRegion(QRect(deltaX, deltaY, width , height));
-            exposedRegion -= QRegion(QRect(deltaX, deltaY, width , height));
-            dbgRender << "exposedRegion: " << exposedRegion;
-        }
-        dbgRender << "exposedRegion: " << exposedRegion;
-        if (!exposedRegion.isEmpty()) {
-
-            QVector<QRect> rects = exposedRegion.rects();
-
-            for (int i = 0; i < rects.count(); i++) {
-                QRect r = rects[i];
-                // Set the areas to empty. Who knows, there may be not
-                // enough image to draw in them.
-                gc.fillRect(r, QColor(0, 0, 0, 0));
-                dbgRender << "render on rect" << r;
-                /**
-                 * FIXME: It can happen that we will need access to KisImage here
-                 */
-                KisPPUpdateInfoSP info = getUpdateInformation(r, QRect());
-                drawUsingBackend(gc, info);
-            }
-        }
-        m_d->prescaledQImage = image;
-    } else {
-        // Don't do "anything" if this function is called while the offset hasn't changed
-        // because that usually happen when the scrollbars appears
-        dbgRender << "Document Offset Moved but without moving !";
+    foreach(QRect rect, rects) {
+        //gc.fillRect(r, QColor(0, 0, 0, 0));
+        KisPPUpdateInfoSP info = getUpdateInformation(rect, QRect());
+        drawUsingBackend(gc, info);
     }
+
+    m_d->prescaledQImage = newImage;
 }
 
 void KisPrescaledProjection::setImageSize(qint32 w, qint32 h)
 {
     m_d->projectionBackend->setImageSize(w, h);
 
-    m_d->imageSize = QSize(w, h);
+    QRect viewportRect = m_d->coordinatesConverter->imageToViewport(QRect(0, 0, w, h)).toAlignedRect();
+    viewportRect = viewportRect.intersected(QRect(QPoint(0, 0), m_d->viewportSize));
 
-    QRect vRect = viewRectFromImagePixels(QRect(0, 0, w, h)).toAlignedRect();
-    vRect = vRect.intersected(QRect(QPoint(0, 0), m_d->canvasSize));
-    if (!vRect.isEmpty()) {
-        preScale(vRect);
+    if (!viewportRect.isEmpty()) {
+        preScale(viewportRect);
     }
 }
 
@@ -273,7 +247,10 @@
     if (!dirtyImageRect.intersects(m_d->image->bounds()))
         return new KisPPUpdateInfo();
 
-    QRect rawViewRect = viewRectFromImagePixels(dirtyImageRect).toAlignedRect();
+
+    QRect rawViewRect =
+        m_d->coordinatesConverter->imageToViewport(dirtyImageRect).toAlignedRect();
+
     KisPPUpdateInfoSP info = getUpdateInformation(rawViewRect, dirtyImageRect);
 
     m_d->projectionBackend->updateCache(info);
@@ -294,8 +271,7 @@
 
 void KisPrescaledProjection::preScale()
 {
-    Q_ASSERT(m_d->canvasSize.isValid());
-    preScale(QRect(QPoint(0, 0), m_d->canvasSize));
+    preScale(QRect(QPoint(0, 0), m_d->viewportSize));
 }
 
 QRect KisPrescaledProjection::preScale(const QRect & rc)
@@ -322,64 +298,63 @@
     m_d->projectionBackend->setMonitorProfile(profile);
 }
 
-void KisPrescaledProjection::resizePrescaledImage(const QSize & newSize)
+
+void KisPrescaledProjection::updateViewportSize()
 {
+    QRectF imageRect = m_d->coordinatesConverter->imageRectInWidgetPixels();
+    QRectF canvasRect(QPointF(0,0), m_d->canvasSize);
+    QRectF minimalRect = imageRect & canvasRect;
 
-    QSize oldSize;
+    m_d->viewportSize = m_d->coordinatesConverter->widgetToViewport(minimalRect).toAlignedRect().size();
 
-    if (m_d->prescaledQImage.isNull()) {
-        oldSize = QSize(0, 0);
-    } else {
-        oldSize = m_d->prescaledQImage.size();
+    if (m_d->prescaledQImage.isNull() ||
+        m_d->prescaledQImage.size() != m_d->viewportSize) {
+
+        m_d->prescaledQImage = QImage(m_d->viewportSize, QImage::Format_ARGB32);
     }
+}
 
-    dbgRender << "KisPrescaledProjection::resizePrescaledImage from " << oldSize << " to " << newSize << endl;
+void KisPrescaledProjection::notifyZoomChanged()
+{
+    updateViewportSize();
+    preScale();
+}
 
-    QImage image = QImage(newSize, QImage::Format_ARGB32);
-//     m_d->prescaledQImage.fill( QColor( 255, 0, 0, 128 ).rgba() );
+void KisPrescaledProjection::notifyCanvasSizeChanged(const QSize &widgetSize)
+{
+    // FIXME: Let someone else figure out the optimization where we copy the
+    // still visible part of the image after moving the offset and then
+    // only draw the newly visible parts
 
-// FIXME: Let someone else figure out the optimization where we copy the
-// still visible part of the image after moving the offset and then
-// only draw the newly visible parts
-
-    m_d->prescaledQImage = image;
-    m_d->canvasSize = newSize;
+    m_d->canvasSize = widgetSize;
+    updateViewportSize();
     preScale();
 }
 
+
 KisPPUpdateInfoSP
 KisPrescaledProjection::getUpdateInformation(const QRect &viewportRect,
                                              const QRect &dirtyImageRect)
 {
-    Q_ASSERT(m_d->viewConverter);
-
     KisPPUpdateInfoSP info = new KisPPUpdateInfo();
 
-    // get the x and y zoom level of the canvas
-    qreal zoomX, zoomY;
-    m_d->viewConverter->zoom(&zoomX, &zoomY);
+    m_d->coordinatesConverter->imageScale(&info->scaleX, &info->scaleY);
 
-    // Get the KisImage resolution
-    qreal resX = m_d->image->xRes();
-    qreal resY = m_d->image->yRes();
-
-    // Compute the scale factors
-    info->scaleX = zoomX / resX;
-    info->scaleY = zoomY / resY;
-
     // save it for future
     info->dirtyImageRect = dirtyImageRect;
 
     // first, crop the part of the view rect that is outside of the canvas
-    QRect croppedViewRect = viewportRect.intersected(QRect(QPoint(0, 0), m_d->canvasSize));
+    QRect croppedViewRect = viewportRect.intersected(QRect(QPoint(0, 0), m_d->viewportSize));
 
     // second, align this rect to the KisImage's pixels and pixels
     // of projection backend
-    info->imageRect = imageRectFromViewPortPixels(QRectF(croppedViewRect));
+    info->imageRect = m_d->coordinatesConverter->viewportToImage(QRectF(croppedViewRect)).toAlignedRect();
+    info->imageRect = info->imageRect & m_d->image->bounds();
+
     m_d->projectionBackend->alignSourceRect(info->imageRect, info->scaleX);
 
     // finally, compute the dirty rect of the canvas
-    info->viewportRect = viewRectFromImagePixels(info->imageRect);
+    info->viewportRect = m_d->coordinatesConverter->imageToViewport(info->imageRect);
 
     info->borderWidth = 0;
     if (SCALE_MORE_OR_EQUAL_TO(info->scaleX, info->scaleY, 1.0)) {
@@ -396,8 +371,6 @@
     }
 
     dbgRender << "#####################################";
-    dbgRender << ppVar(resX) << ppVar(resY);
-    dbgRender << ppVar(zoomX) << ppVar(zoomY);
     dbgRender << ppVar(info->scaleX) << ppVar(info->scaleY);
     dbgRender << ppVar(info->borderWidth) << ppVar(info->renderHints);
     dbgRender << ppVar(info->transfer);
@@ -432,47 +405,4 @@
     }
 }
 
-QRectF KisPrescaledProjection::viewRectFromImagePixels(const QRect& rc)
-{
-    Q_ASSERT(m_d->viewConverter);
-
-    qreal xRes = m_d->image->xRes();
-    qreal yRes = m_d->image->yRes();
-
-    QRectF imageRect(rc);
-
-    QRectF docRect;
-    docRect.setCoords(imageRect.left() / xRes, imageRect.top() / yRes,
-                      imageRect.right() / xRes, imageRect.bottom() / yRes);
-
-    QRectF viewRect = m_d->viewConverter->documentToView(docRect);
-    viewRect = viewRect.translated(-m_d->documentOffset);
-
-    QRectF viewRectInter = viewRect.intersected(QRectF(0, 0, m_d->canvasSize.width(), m_d->canvasSize.height()));
-
-    if (viewRect != viewRectInter && !viewRectInter.isEmpty()) {
-        dbgRender << "*** Bad alignment of viewport rect ***";
-        dbgRender << "* Calculated: " << viewRect;
-        dbgRender << "* Must be:    " << viewRectInter;
-        dbgRender << "*** ****************************** ***";
-    }
-
-    return viewRect;
-}
-
-QRect KisPrescaledProjection::imageRectFromViewPortPixels(const QRectF& viewportRect)
-{
-    QRectF intersectedRect = viewportRect;//.intersected(QRectF(0, 0, m_d->canvasSize.width(), m_d->canvasSize.height()));
-    QRectF translatedRect = intersectedRect.translated(m_d->documentOffset);
-    QRectF docRect = m_d->viewConverter->viewToDocument(translatedRect);
-
-    return m_d->image->documentToPixel(docRect).toAlignedRect().intersected(m_d->image->bounds());
-}
-
-
-void KisPrescaledProjection::updateDocumentOrigin(const QPoint& documentOrigin)
-{
-    m_d->documentOrigin = documentOrigin;
-}
-
 #include "kis_prescaled_projection.moc"
